BEGIN{
FS="::"
toanalyse=0
okprintomp=0

print "! MODULE       : livestock_parameters_var                                                                                                                                                                                                                                                                                   "
print "!																																						     "
print "! CONTACT      : orchidee-help _at_ listes.ipsl.fr																																     "
print "!																																						     "
print "! LICENCE      : IPSL (2011)																																			     "
print "! This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC																												     "
print "!																																						     "
print "!>\BRIEF        This module contains the variables in function of livestock type (livestock).																											     "
print "!!																																						     "
print "!! DESCRIPTION: This module contains the declarations for the externalized variables in function of the 																									     "
print "!!                livestock type(livestock). \n																																	     "
print "!!                The module is already USE in module livestock_parameters. Therefor no need to USE it seperatly except																								     "
print "!!                if the subroutines in module livestock_parameters are not needed.\n																													     "
print "!!																																						     "
print "!! RECENT CHANGE(S): None																																			     "
print "!!																																						     "
print "!! REFERENCE(S) : None																																				     "
print "!!																																						     "
print "!! SVN          :																																				     "
print "!! $HeadURL: $																																					     "
print "!! $Date: $																																     "
print "!! $Revision: $																																				     "
print "!! \n																																						     "
print "!_ ================================================================================================================================																						     "
print "																																							     "
print "MODULE livestock_parameters_var																																			     "
print "																																							     "
print "  USE defprec																																					     "
print "  																																						     "
print "  IMPLICIT NONE                                                                                                                                                                                                                                                                                                       "


print " INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION(:) :: livestock_to_lmtc  !! Table of conversion : we associate one pft to one metaclass "
print "                                                                 !! (1-13, unitless)"
print "!$OMP THREADPRIVATE(livestock_to_lmtc)"
print
print " LOGICAL, SAVE   :: l_first_livestock_parameters = .TRUE.             !! To keep first call trace of the module (true/false)"
print "!$OMP THREADPRIVATE(l_first_livestock_parameters)"

}
{
    if($2!="")
    { 

	if(toanalyse &&(myvar != "")&& !okprintomp)
	{
	    print "!$OMP THREADPRIVATE("myvar")"
	}

	okprintomp=0
	var="echo \""$2"\"|sed -e 's/\=\.\*//'"
	var | getline myvar
	close(var)

	var="echo \""myvar"\"|sed -e 's/_lmtc//'"
	var | getline myvar
	close(var)

	var="echo \""myvar"\"|sed -e 's/\ //g'"
	var | getline myvar
	close(var)


	if(myvar=="nlmc") toanalyse=1

	if(myvar=="nlmc") myvar="nlm"
	if(myvar=="LMTC_name") myvar="LIVESTOCK_name"

	if(myvar=="nlm")
	{
	    declar="echo \""$1"\"|sed -e 's/PARAMETER/SAVE/'"
	    declar | getline mydeclar
	    close(declar)
	}
	else
	{
	    declar="echo \""$1"\"|sed -e 's/PARAMETER/ALLOCATABLE, SAVE/'"
	    declar | getline mydeclar
	    close(declar)
	}
	declar="echo \""mydeclar"\"|sed -e 's/nlmc/:/'"
	declar | getline mydeclar
	close(declar)


	comment="echo \""$2"\"|sed -e 's/\\(.*\\)\!!\\(.*\\)/!!\\2/'"
	comment | getline mycomment
	close(comment)

	
	if(toanalyse) printf("\n%s %s %s\t%s\n", mydeclar, " :: ",myvar,mycomment)
    }
    else
    {
	comment="echo \""$1"\"|sed -e 's/\ //g'"
	comment | getline mycomment
	close(comment)
	if(substr(mycomment,1,1)=="!") 
	{
	    if(!okprintomp &&(myvar != "") )
	    {
		print "!$OMP THREADPRIVATE("myvar")"
		okprintomp=1
	    }
	    if(toanalyse) print $0
	}
	else
	{
	    comment="echo \""$1"\"|sed -e 's/\\([^!]*\\)\\(.*\\)/\\2/'"
	    comment | getline mycomment
	    close(comment) 
	    if(toanalyse &&(mycomment!="")) printf("\t\t\t\t\t\t\t\t%s\n",mycomment)
	}
    }
}
END{
    print "!$OMP THREADPRIVATE("myvar")"
    print "END MODULE livestock_parameters_var"
}
